
#include "defs1.h"

  /* La funzione create_indexed_file() crea una copia del file e la chiama con lo stesso nome del file originale ma con estesnsione '.ndx' */
 void create_indexed_file(char *html_file, char *ndx_file)
  {
    static char *ext, ar_bf[256], c, *file_str;
    int i;
    FILE *fn, *bf;
    for(i=0; *(html_file+i)!='\0';i++)
      ar_bf[i]=*(html_file+i);
    ar_bf[i]='\0';
    ext=strstr(ar_bf,".html");
    *(ext+1)='n';
    *(ext+2)='d';
    *(ext+3)='x';
    *(ext+4)='\0';
    for(i=0;(*(ndx_file+i)=ar_bf[i])!='\0';i++);

    fn=open(html_file,"r");
    for(i=0;!feof(fn);i++)
      fgetc(fn);
    if((file_str=(char *)calloc((i+1),sizeof(char)))==NULL)
      {
       printf("\nErrore nell'allocazione di memoria...\nProgramma abortito!\n");
       exit(0);
      }
    fseek(fn,0,SEEK_SET);
    for(i=0;!feof(fn);i++)
      *(file_str+i)=fgetc(fn);
    *(file_str+i+1)='\0';
    fclose(fn);

    bf=open(ndx_file,"w+");
    for(i=0;(c=file_str[i])!='\0';i++)
      fputc(c,bf);
    fclose(bf);

    return;
  }


 /* La funzione clean_nl() elimina dal file i new_line */
 int clean_nl(char *file_name)
   {
  FILE *temp, *f2c;
  char c;
  int nl=0;

  temp=open("indexer.tmp","w+");
  f2c=open(file_name,"r");

    do
      {
        c=fgetc(f2c);
        if (c!='\n') fputc(c, temp);
          else
          {
            fputc(' ', temp);
            nl++;
          }
      }
    while(!feof(f2c));
    fclose(f2c);
    fclose(temp);
    remove(file_name);
    rename("indexer.tmp",file_name);
    return nl;
  }


 void listing(char *dir_name, char *options, char *tmp_file)
 {
   char cmd_p[255]="ls";
   char file[255]="";
   strcat(cmd_p," -m");
   strcat(cmd_p," ");
   strcat(cmd_p,dir_name);
   strcat(cmd_p," > ");
   strcat(cmd_p,dir_name);
   strcat(cmd_p,"/");
   strcat(cmd_p,tmp_file);
   system(cmd_p);
   strcat(file,dir_name);
   strcat(file,"/");
   strcat(file,tmp_file);
   clean_nl(file);
   return;
 }


 int dir_processing(char *dir_name, char *dir_list_tmp_file)
 {
   FILE *df;
   static char file_name[255], path[255], path_fname[255];
   char c;
   int i=0, count=0;
   for(i=0;*(dir_name+i)!='\0';i++)
     path_fname[i]=*(dir_name+i);
   strcat(path_fname,"/");
   strcat(path_fname,dir_list_tmp_file);
   df=open(path_fname,"r");

   while(!feof(df))
     {
       for(i=0;(c=fgetc(df))!=',';i++)
         file_name[i]=c;
       file_name[i+1]='\0';
       path[0]='\0';

       strcat(path,dir_name);
       strcat(path,"/");
       strcat(path,file_name);
       count=count+check_file(path);
       c=fgetc(df);
       while(fgetc(df)==' ');
       fseek(df,-1,SEEK_CUR);
     }
     fclose(df);
     return count;
 }

 int check_file(char *f_name)
 {
   int i;

   for(i=0;*(f_name+i)!='\0';i++);
   if(strcmp((f_name+i-5),".html")==0)
     {
       printf("\nSto processando il file '%s'...\n",f_name);
       start_cleaning(f_name);
       return 1;
     }
   return 0;
 }


 /* La funzione open() apre il file da modificare e restituisce un puntatore a tale file */
 FILE *open(char *file_name, char *access_mode)
  {
    FILE *fp;
    if ((fp=fopen(file_name, access_mode))==NULL)
      {
        printf("\nErrore nella funzione <open()>\nErrore nell'apertura / creazione del file %s in modalita' %s...\nProgramma abortito!\n", file_name, access_mode);
        exit(0);
      }
    return fp;
  }


 int start_cleaning(char *html_file)
   {
     int count=0;
     static char ndx_file[255];

     printf("\nCreazione file da indicizzare.....");
       create_indexed_file(html_file,ndx_file);
     printf("[OK]...creato file <%s>", ndx_file);
       count=clean_nl(ndx_file);
     printf("[OK]...%d\tnew_line eliminati",count);

     return SUCCESS;
   }
